% P? markerade st?llen i koden ska ni givet f?ljande variabler:
%   - N   antalet observationer f?r varje teststorhet
%   - U   en Nx3-matris U = [u(1);u(2);...;u(N)];
%   - Y   en Nx1-matris Y = [y(1);y(2);...;y(N)];
%   - pfa falskalarmssannolikheten
% konstruera tre teststorheter Ti, i = 1,2,3 normerade s? att P(T>1|H0) =
% pfa.
clear

% S?tta parametrar
M = 1000;       % antalet realiseringar 
N = 100;        % antalet observationer f?r varje teststorhet.
pfa = 0.01;     % falskalarmssannolikheten
fs = 1;         % felstorlek

%% Generera observationer
[data] = GenerateTestData(M,N,fs);
% funktionen [data] = GenerateTestData(M,N,fs); genererar observationer f?r
% de fyra moderna NF, F1, F2 och F3. F?r varje mod genereras M:st olika
% realiseringar, s? observationerna f?r den i:te realiseringen f?r mod Fj
% lagras som:
%
% data.Fj.u
% data.Fj.y{i}
% 
% Notera att u ?r samma f?r alla realiseringar det ?r bara utsignalerna y{i} som
% skiljer dem ?t.


%% K?r testerna f?r alla moder och alla realiseringar.
% Testresultaten sparas i "results" som f?r varje mod Fj inneh?ller f?ljande tv?
% kategorier:
%
% results.Fj =
%
%    T: [Mx3 double]
%    A: [Mx3 logical]
% 
% B?de T och A ?r matriser med M rader, en f?r varje realisering, och 3
% kolonner, en f?r varje test. T(i,:) inneh?ller v?rdet f?r de tre
% normerade testerna applicerad p? observationer fr?n den i:te
% realiseringen och A(i,:) de tr?sklade v?rdena. Om vi vill veta vilka
% tester som larmade f?r den i:te realisering av mod Fj g?rs anropet:
%
% results.Fj.A(i,:)

modes = {'NF','F1','F2','F3'};
for i = 1:M
    for j = 1:length(modes)
        eval(['Y = data.' modes{j} '.y{i};']);
        eval(['U = data.' modes{j} '.u;']);

        % H?r ska teststorheten som definieras i uppgift a) ber?knas
        T1 = 0; 
        
        %  H?r ska teststorheten som definieras i uppgift b) ber?knas
        T2 = 0; 
        
        %  H?r ska teststorheten som definieras i uppgift c) ber?knas
        T3 = 0; 
       
        % Sammanst?ller resultatet
        T = [T1 T2 T3];
        A = T>1;
        results.(modes{j}).T(i,:) = T;
        results.(modes{j}).A(i,:) = A;
    end
end

% Anv?nd "results" f?r att skatta sannolikheten f?r alarm P(Ti > 1|m) f?r 
% i = 1,2,3 och m = 'NF', 'F1', 'F2', 'F3' h?r.  
