%% Exercise 3.19

clc
close all
%% a
clear
load cusum_a

N = length(x);

mu0   = 0;
mu1   = 0.3;
sigma = 1;

score_fun = @(x) WRITE YOUR CODE HERE;

% Initialize result variables
S       = zeros(N,1); % Direct cumulative sum
Tcusum  = zeros(N,1); % USUM test quantity
Tcusum2 = zeros(N,1); % Simplified CUSUM test quantity (4.43)

Tcusum(1) = 0;
S(1)      = score_fun(x(1));
mk        = S(1);
tchhat    = NaN;
for k=2:N
  S(k) = S(k-1) + score_fun(x(k));
  if  S(k) < mk
    mk = S(k);
    tchhat = k;
  end
  Tcusum(k) = S(k)-mk;
  Tcusum2(k) = max([0,Tcusum2(k-1) + score_fun(x(k))]);
end

figure(10)
plot( x )

figure(11)
plot( S );

figure(12)
plot( [Tcusum Tcusum2])
hold on
plot( [tchhat tchhat], [min(Tcusum) max(Tcusum)], 'r')
text( tchhat+10, max(Tcusum)*0.9, 't_c_h', 'FontSize',14)
hold off

%% b
clear
load cusum_b
N = length(x);

sigma0 = 1;
sigma1 = 1.2;
mu     = 0;

score_fun = @(x) WRITE YOUR CODE HERE;

T = zeros(N,1); % Simplified CUSUM test quantity (4.43)
for k=2:N
  T(k) = max([0,T(k-1) + score_fun(x(k))]);
end
tchhat = find(T==0,1,'last');

figure(20)
plot( x )

figure(21)
plot( T )
hold on
plot( [tchhat tchhat], [min(T) max(T)], 'r')
text( tchhat+10, max(T)*0.9, 't_c_h', 'FontSize',14)
hold off

%% c
clear
load cusum_a

N  = length(x);

mu0 = 0;
mu1 = 0.3;
sigma = 1;

score_fun = @(x,theta1) WRITE YOUR CODE HERE;

Tcusum = zeros(N,1); % Simplified CUSUM test quantity (4.43)
Tglr   = zeros(N,1); % GLR test quantity

Tglr(1) = WRITE YOUR CODE HERE;
for k=2:N
  % CUSUM
  Tcusum(k) = max([0,Tcusum(k-1) + score_fun(x(k),mu1)]);
  
  % GLR
  lrmax = -inf;
  % Naive maximization, complete search for optimal tch
  for tch=1:k
    theta1_hat = WRITE YOUR CODE HERE;
    lr = sum(score_fun(x(tch:k),theta1_hat));
    if lr > lrmax;
      lrmax = lr;
    end
  end
  Tglr(k) = lrmax;
end
figure(30)
plot( x )

figure(31)
plot( [Tglr Tcusum] )

%% d
clear
load cusum_a

N = length(x);

mu0   = 0;
mu1   = 0.3;
sigma = 1;

score_fun = @(x) WRITE YOUR CODE HERE;

% Initialize result variables
Tcusum = zeros(N,1); % Simplified CUSUM test quantity (4.43)
tchhat    = NaN;

for k=2:N
  Tcusum(k) = max([0,Tcusum(k-1) + score_fun(x(k))]);
end

% Low-pass filter the residual
[b,a] = butter(WRITE YOUR CODE HERE);
Tlp   = abs(filter(b,a,x));

figure(40)
plot( x )

figure(41)
plot( [Tcusum Tlp] )
hold on
plot( [tchhat tchhat], [min(Tcusum) max(Tcusum)], 'r')
text( tchhat+10, max(Tcusum)*0.9, 't_c_h', 'FontSize',14)
hold off

