function y = diagsys(x)

% Calculate the log of the maximum likelihood ratios:

lnT1 = max(lnLmu(x), lnLstd(x)) - lnL0(x)
lnT2 = lnLstd(x) - lnLmu(x)
lnT3 = lnLmu(x) - lnLstd(x)

% The thresholds are:

J1 = 10;
J2 = 10;
J3 = 10;

% The diagnosis statements of the individual tests:

if lnT1 < J1
  S1 = {'NF', 'MC', 'DC'}
else
  S1 = Write your code here!
end

if lnT2 < J2
  S2 = {'NF', 'MC', 'DC'}
else
  S2 = Write your code here!
end

if lnT3 < J3
  S3 = {'NF', 'MC', 'DC'}
else
  S3 = Write your code here!
end

% The diagnosis statements of the whole system:

S = (intersect(intersect(S1,S2), S3))'


% If a fault is detected, then the changetime and change-to-value is:

if ~ismember('NF', S)
  if ismember('DC', S)
    [lnL, tch, s_ch] = lnLstd(x);
	tch, s_ch
  end
  if ismember('MC', S)
    [lnL, tch, mu_ch] = lnLmu(x);
	tch, mu_ch
  end
end
  

% The log-likelihood function log(L) assuming fault mode NF

function lnL = lnL0(x)

Write your code here!


% The log-likelihood function log(L) assuming fault mode MC

function [lnL, tch, mu_ch] = lnLmu(x)
N = length(x);
s2 = 1;
for t=1:N,
  muopt(t) = mean(x(t:N));
  sum1 = sum(x(1:t-1).^2/2/s2+log(sqrt(2*pi*s2)));
  sum2 = sum((x(t:N)-muopt(t)).^2/2/s2+log(sqrt(2*pi*s2)));
  tsum(t) = -sum1 - sum2;
end
tch=find(max(tsum)==tsum);
lnL = tsum(tch);
mu_ch = muopt(tch);


% The log-likelihood function log(L) assuming fault mode DC

function [lnL, tch, s_ch] = lnLstd(x)
N = length(x);

Write your code here!
