# TSFS06: Diagnosis and supervision

<b>Changes for 2025: TSFS06 (VT2) is replaced by the new course TSFS22 Fault Detection and Diagnosis of Technical Systems (HT1)</b>

This repository includes lecture notes, material for hand-in exercises, links to reading material, and other course material. Information here will be added during the course and you can always get the latest version of course material here.

See below for information about:
1. [_Course material_](#course_material)
2. [_Lectures_](#lectures)
3. [_Exercises_](#exercises)
4. [_Labs_](#labs)

# <a name="course_material"></a>Course material

The course material is available in electronic form and can be downloaded from the links below.

* Main text: M. Nyberg och E. Frisk "[_Diagnosis of Technical Processes_](https://www.fs.isy.liu.se/Edu/Courses/TSFS06/PDFs/tsfs06_2020.pdf)"
* [_Exercises_](https://www.fs.isy.liu.se/Edu/Courses/TSFS06/PDFs/tsfs06_2021_exercises.pdf) corresponding to the main text.
* Excerpt from the book: M. Basseville, I.Nikiforov "[_Detection of Abrupt Changes_](https://www.fs.isy.liu.se/Edu/Courses/TSFS06/PDFs/Basseville.pdf)"<br>
**Reading instructions**: Chapter 2 can be read but sections 2.2.2, 2.2.4, 2.2.6, 2.3, 2.4.2, 2.4.3.2, 2.5, 2.6  can be considered as advanced and is not part of the course.<br>
The book is out of print and can be downloaded from http://people.irisa.fr/Michele.Basseville/kniga/.
* Links to lab-instructions can be found below
* The part of the course devoted to probabilistic diagnosis will use the free software [_GeNIe_](https://www.bayesfusion.com/genie/). It is a Windows based software that is free for everyone to download and install at home.

# <a name="lectures"></a>Lectures
All reading instructions refer to the main text "[_Diagnosis of Technical Processes_](https://www.fs.isy.liu.se/Edu/Courses/TSFS06/PDFs/tsfs06_2020.pdf)" unless otherwise specified.

## Lecture 1 - Course introduction and course organization [[slides](Lectures/lecture_01.pdf)]
**Date**: 26/3<br>
**Reading instructions**: Chapter 1

* [_Introduction to the course and diagnosis_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%201/F%C3%B6rel%C3%A4sning%2001a-20210321_045501.mp4) (19:24)
* [_The diagnosis problem and redundancy_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%201/F%C3%B6rel%C3%A4sning%2001b-20210321_050032.mp4
) (21:01)
* [_Introduction to fault isolation_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%201/F%C3%B6rel%C3%A4sning%2001c-20210321_051019.mp4) (14:54)
* [_Introduction to fault modeling_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%201/F%C3%B6rel%C3%A4sning%2001d-20210321_052153.mp4) (21:44)

## Lecture 2 - Single fault isolation [[slides](Lectures/lecture_02.pdf)]
**Date**: 27/3<br>
**Reading instructions**: Chapter 2 except 2.4, Chapter 3 to (and including) 3.4

* [_Introduction and formal definitions_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%202/F%C3%B6rel%C3%A4sning%2002a-20210320_010821.mp4) (22:21)
* [_Method for single fault isolation and decision making in uncertain environments_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%202/F%C3%B6rel%C3%A4sning%2002b-20210320_011457.mp4) (16:03)
* [_Isolability properties of a model_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%202/F%C3%B6rel%C3%A4sning%2002c-20210320_012633.mp4) (21:37)
* [_Isolability for set of tests, summary, and examples_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%202/F%C3%B6rel%C3%A4sning%2002d-20210320_014859.mp4) (24:04)

## Lecture 3 - Linear residual generation [[slides](Lectures/lecture_03.pdf)]
**Date**: 3/4<br>
**Reading instructions**: Sections 4.1, 4.3, Chapter 6 except 6.6

* [_Background and basic principles_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%203/F%C3%B6rel%C3%A4sning%2003a-20210320_024206.mp4) (17:40)
* [_Diagnosis of differential-algebraic Models_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%203/F%C3%B6rel%C3%A4sning%2003b-20210320_024207.mp4) (14:22)
* [_Formal definitions and a method for static models_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%203/F%C3%B6rel%C3%A4sning%2003c-20210320_024908.mp4) (19:26)
* [_A mtethod for dynamic DAE-models_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%203/F%C3%B6rel%C3%A4sning%2003d-20210320_030825.mp4) (35:09)
* [_Concluding example and Matlab demonstration_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%203/F%C3%B6rel%C3%A4sning%2003e-20210320_031416.mp4) (16:46)

## Lecture 4 - Linear residual generation and detectability [[slides](Lectures/lecture_04.pdf)]
**Date**: 9/4<br>
**Reading instructions**: Section 6.6

* [_Linear residual generation and degrees of freedom_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%204/F%C3%B6rel%C3%A4sning%2004a-20210320_045316.mp4) (19:17)
* [_Detectability and isolability_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%204/F%C3%B6rel%C3%A4sning%2004b-20210320_045408.mp4) (19:38)
* [_Design parameters and strong detectability_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%204/F%C3%B6rel%C3%A4sning%2004c-20210320_045129.mp4) (17:03)
* [_Limitations and design_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%204/F%C3%B6rel%C3%A4sning%2004d-20210320_045423.mp4) (09:26)

## Lecture 5 - Design of test quantities [[slides](Lectures/lecture_05.pdf)]

**Date**: 11/4<br>
**Reading instructions**: Sections 4.2, 4.4, 4.5

* [_Behavioral modes, models, and model validation_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%205/F%C3%B6rel%C3%A4sning%2005a-20210320_050545.mp4) (33:48)
* [_Prediction error methods_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%205/F%C3%B6rel%C3%A4sning%2005b-20210320_051915.mp4) (28:50)
* [_Parameter estimates and llikelihood models_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%205/F%C3%B6rel%C3%A4sning%2005c-20210320_055824.mp4) (22:02)


## Lecture 6 - Thresholding and analysis of test quantities [[slides](Lectures/lecture_06.pdf)]

**Date**: 16/4<br>
**Reading instructions**: Section 4.6, Chapter 5

* Repetition material: [_Some basics on multivariable random variables_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Stokastiska%20variabler-20210320_014950.mp4) (08:49)
* [_Thresholding and decisions under uncertainty_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%206/F%C3%B6rel%C3%A4sning%2006a-20210418_044815.mp4) (25:23)
* [_Thresholding in an ideal case_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%206/F%C3%B6rel%C3%A4sning%2006b-20210418_045112.mp4) (20:18)
* [_Adaptive thresholds_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%206/F%C3%B6rel%C3%A4sning%2006c-20210418_045058.mp4) (21:30)
* [_Performance of test quantities_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%206/F%C3%B6rel%C3%A4sning%2006d-20210418_045415.mp4) (22:44)

## Lecture 7 - Nonlinear residual generation [[slides](Lectures/lecture_07.pdf)]

**Date**: 23/4<br>
**Reading instructions**: Chapter 7

* [_Introduction_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%207/F%C3%B6rel%C3%A4sning%2007a-20210418_050105.mp4) (07:37)
* [_Nonlinear observers for diagnosis_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%207/F%C3%B6rel%C3%A4sning%2007b-20210418_050854.mp4) (41:38)
* [_Nonlinear consistency relations for diagnosis_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%207/F%C3%B6rel%C3%A4sning%2007c-20210418_052611.mp4) (25:39)
* [_Design examples_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%207/F%C3%B6rel%C3%A4sning%2007d-20210418_053227.mp4) (24:02)

## Lecture 8 - Change detection [[slides](Lectures/lecture_08.pdf)]

**Date**: 26/4<br>
**Reading instructions**: Section 4.7 + excerpts from the book by M. Basseville, I.Nikiforov "[_Detection of Abrupt Changes_](https://www.fs.isy.liu.se/Edu/Courses/TSFS06/PDFs/Basseville.pdf)".

* [_Introduction to change detection_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%208/F%C3%B6rel%C3%A4sning%2008a-20210502_090037.mp4) (18:02)
* [_Algorithms for change detection_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%208/F%C3%B6rel%C3%A4sning%2008b-20210502_090042.mp4) (21:25)
* [_Derivation of CUSUM_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%208/F%C3%B6rel%C3%A4sning%2008c-20210502_090046.mp4) (18:25)
* [_CUSUM and residuals_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%208/F%C3%B6rel%C3%A4sning%2008d-20210502_090050.mp4) (16:52)

## Lecture 9 - Multiple fault isolation [[slides](Lectures/lecture_09.pdf)]

**Date**: 7/5<br>
**Reading instructions**: Sections 2.4, 3.5-3.7

* [_Introduction to multiple fault isolation_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%209/F%C3%B6rel%C3%A4sning%2009a-20210502_093058.mp4) (09:10)
* [_Basic definitions and characterization of multiple fault diagnoses_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%209/F%C3%B6rel%C3%A4sning%2009b-20210502_093059.mp4) (14:40)
* [_Mupltiple faults and residual generation_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%209/F%C3%B6rel%C3%A4sning%2009c-20210502_093100.mp4) (11:57)
* [_Fault isolation algorithm_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%209/F%C3%B6rel%C3%A4sning%2009d-20210502_093101.mp4) (20:42)

## Lecture 10 - Probabilistic diagnosis and Bayesian networks [[slides](Lectures/lecture_10.pdf)]

**Date**: 14/5<br>
**Reading instructions**: Chapter 8

* [_Introduction to probabilistic diagnosis_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%2010/F%C3%B6rel%C3%A4sning%2010a-20210502_094512.mp4) (17:46)
* [_Introductory example and notation_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%2010/F%C3%B6rel%C3%A4sning%2010b-20210502_094513.mp4) (15:31)
* [_Probabilistic models for diagnosis_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%2010/F%C3%B6rel%C3%A4sning%2010c-20210502_094519.mp4) (10:46)
* [_Bayesian networks_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%2010/F%C3%B6rel%C3%A4sning%2010d-20210502_095338.mp4) (21:58)
* [_Canonical models_](https://liuonline.sharepoint.com/:v:/r/sites/VehicularSystemsEDU/Shared%20Documents/TSFS06/Lecture%2010/F%C3%B6rel%C3%A4sning%2010e-20210502_095341.mp4) (17:02)

# <a name="exercises"></a>Exercises
Below is a list of the exercise sessions and corresponding material.

|Date | Exercise| Topic	| Exercises |	All exercises	| Misc |
|-----|-------|-------|-----------|-------------------|------|
| 28/3 | 1 | Introduction | 1.1-7, 1.9, 1.10, 1.14	| 1.1-1.14||
| 2/4 | 2 | Fault isolation | 2.1, 2.2, 2.4, 2.5, 2.6, 2.7, 2.8, 2.9	| 2.1-2.11||
| 5/4 | 3 | Linear residual generation | 4.1, 4.3, 4.4 a-b, 4.6 a-b, 4.9, 4.15 a-b, 4.19, 4.12, 4.13, 4.6 c-e	| 4.1-4.24 | [help](Exercise_data/del3_4.pdf)|
| 10/4 | 4 | Linear residual generation (D) | 4.15c, 4.17, 4.20, 4.4c | | [help](Exercise_data/lab1help.pdf), [Matlab help](Labs/Lab1_LinearResidualGeneration/lab1matlabhelp.pdf)|
| 17/4 | 5 | Design of test quantities | 3.1, 3.5, 3.4, 3.6, 3.9 | 3.8, 3.10, 3.11, 3.12, 3.16, 3.17 ||
| 19/4 | 6 | Design of test quantities (D) | 3.2, 3.7, 3.13, 3.18, 3.15 | 3.3, 3.14a-c | [data](Exercise_data/Data)|
| 24/4 | 7 | Nonlinear residual generation | 5.1, 5.2, 5.5, 5.6, 5.7, 5.8, 5.3 | 5.1-5.12 ||
| 3/5 | 8 | Change detection (D) | 3.19, 3.20, 3.21, 3.22 | | [data](Exercise_data/Data)|
| 8/5 | 9 | Multiple fault isolation | 6.3, 6.4, 6.5, 6.1, 6.2, 6.6, 6.7, 6.8 | ||
| 15/5 | 10 | Probabilistic diagnosis (D) | 7.2, 7.3, 7.4, 7.6 | 7.1-7.7 | [GeNIe-tutorial](Exercise_data/genie_tutorial.pdf)|

# <a name="labs"></a>Labs

## 1. Linear residual generation: ([_Lab_](Labs/Lab1_LinearResidualGeneration/TSFS06lab1.pdf), [_files_](Labs/Lab1_LinearResidualGeneration))

**Helptexts**: [_Linear residual generation_](Exercise_data/lab1help.pdf), [_matlab_](Labs/Lab1_LinearResidualGeneration/lab1matlabhelp.pdf)<br>
**Date**: Thursday, April 18, 13:15 - 17:00<br>
**Last day to hand-in preparatory assignments**: April 15<br>
**Deadline for report**: April 25

Solutions are reported with a short written report submitted through Lisam. There is no need for an extensive report, neither for the preparatory exercises not the final report. Short answers to the questions and relevant plots included is sufficient.

## 2. Diagnosis of a fuel evaporative system ([_Lab_](Labs/Lab2_PurgeSystem/TSFS06lab2.pdf), [_files_](Labs/Lab2_PurgeSystem))

Based on the paper:<br>
[_Leakage Detection In a Fuel Evaporative System_](https://www.fs.isy.liu.se/Edu/Courses/TSFS06/Laborationer/LeakageDetection_CEP2009.pdf)),
Control Engineering Practice, 17(11):1273--1279,
Mattias Krysander, and Erik Frisk (2009) <br>
DOI: https://doi.org/10.1016/j.conengprac.2009.06.003

**Date**: Thursday, April 25, 13:15 - 17:00<br>
**Deadline for report**: May 2

The report must be submitted in PDF format through Lisam. The report should look professional and neat, I encourage you to use the Word/LaTeX templates available at https://www.ifac-control.org/events/author-guide.

## 3. Nonlinear residual generation ([_Lab_](Labs/Lab3_NonlinearDiagnosis/TSFS06lab3.pdf), [_files_](Labs/Lab3_NonlinearDiagnosis))
**Date**: Thursday, May 2, 13:15 - 17:00<br>
**Deadline for report**: May 9

The report must be submitted in PDF format through Lisam. The report should look professional and neat, I encourage you to use the Word/LaTeX templates available at https://www.ifac-control.org/events/author-guide.
